/* wagon-ESP-OSC
 *  un wagon radio-guidÃ©
 *  plateforme ESP8266 ESP-12
 *  commande moteur Olimex BB-L298
 *  protocole rÃ©seau OSC
 *  SNHack gepeto@du-libre.org
 *  Codes sous licences GPLV3
 */

/* projet LOCO-DOM
 *  IP du rÃ©seau 192.168.0.x/24
 *  les loco sont de x= 81 a 91
 *  ports 9081 a 9091
 * Connexions ESP-12 BBL-298
 * |-                |   ESP-12   |          |        -|
   |-                |      RST   |       TXD|        -|
   |LDR              | ADC        |       RXD|       - |
   |-                |CH_P        |    GPIO4 |  1 RFID |
   |4 BBL            |   GPIO16   |    GPIO5 |        -|
   |3 BBL            |   GPIO14   |    GPIO0 |        -|
   |led bleu2 BBL-298|   GPIO12   |    GPIO2 |        -|
   |led verte        |   GPIO13   |   GPIO15 |led rouge|
   |-                |   VCC 3V   |       GND|        -|
 *
 */

// WIFI
#include <ESP8266WiFi.h>
#include <WiFiUdp.h>
#include <Ticker.h> // gestion des timer
#define TAILLE_PUCE 12
#define TAILLE_TABLEAU_PUCES 480 // 40 x 12
//MDNSResponder mdns;
// OSC
#include <OSCBundle.h>
#include <OSCMessage.h>
#include <OSCBoards.h>
//port numbers for OSC
const unsigned int inPort = 9081;
//destination IP pour la trace OSC
IPAddress MonitIP(192, 168, 0, 99); // IP et port du moniteur
const unsigned int MonitPort = 9998; // suivi normal
IPAddress DebugIP(192, 168, 0, 123); // IP et port de debug
const unsigned int DebugPort = 9999;
WiFiUDP udpin;
WiFiUDP udpout;
Ticker zou; // OSC envoi position
Ticker init_rfid; // init port rfid
#include <ArduinoJson.h>
#include "FS.h"
// serial
#include <EspSoftSerialRx.h>
EspSoftSerialRx rfid;
const char* ssid     = "LOCOMO";
const char* password = "0123456789";
char nomhost[20]  = "LOCO-2";
// DHCP donc pas besoin
//IP
//IPAddress (192,168,IPC,IPD);
int IPC = 0;
int IPD = 81;
String nom = "LOCO-2";
char* OSCVar = "/LOCO-2";

// connect motor controller pins to Arduino digital pins
// ESP moteur traction
const int enA = 2;  //nodeCU D4
const int in1 = 14; //nodeCU D6
const int in2 = 12; //nodeCU D5
const int ENTREERFID = 13 ; //NodeCU D7
int Vitesse_actuelle = 0 ; // vitesse actuelle
uint32_t temps_boucle_total = 14000 ; // en milli seconde
uint32_t temps_a_faire = 0;
uint32_t temps_depart = 0;
uint32_t temps_inter = 0;
uint32_t temps_tot_puce = 0;
int rampe_moyenne = 20; // >0 AV <0 ARR
int rampe = 0;
char buf0[] = "00000000000000000000";
char tag[TAILLE_PUCE + 1];
unsigned char val = 0x00;
char TablePuce[TAILLE_TABLEAU_PUCES];
const int nbr_max_de_puce = 20;
int distance_entre_puce = 43 ; // cm
int distance_totale = 516 ; //cm
int nbr_de_puce = 0;
int no_puce_actuelle = 0;
int puce_a_trouver = 0;
int puce_derniere_lue = 0;
int tour = 0;
// tableau des puces rfid 20x12
//char TableauPuces[nbr_max_de_puce][TAILLE_PUCE] = {
char TableauPuces[nbr_max_de_puce][TAILLE_PUCE + 1] = {
  "999999999999", // puce 0 inexistante on commence a 1 pour json
  /*  "0103FA188262", // 1
    "0103FA186989", // 2
    "0103FA187292", // 3
    "0103FA19E908", // 4
    "0103FA19FA1B", // 5
    "0103FA199475", // 6
    "0103FA1A6F8D", // 7
    "0103FA1933D2", // 8
    "0103FA1AE604", // 9
    "0103FA197A9B", // 10
    "0103FA1A09EB", // 11
    "0103FA19DE3F", // 12
  0103FA1A7795
  0103FA1ADD3F
  */
  "0103FA1ADD3F", // 1
  "0103FA1A7795", // 2
  "0103FA19B958", // 3
  "0103FA1A7193", // 4
  "0103FA1A0CEE", // 5
  "0103FA1A21C3", // 6
  "0103FA1A8A68", // 7
  "0103FA1AC321", // 8
  "0103FA19EB0A", // 9
  "0103FA1A9F7D", // 10
  "0103FA1A9072", // 11
  "0103FA199A7B", // 12
  "000000000000", // 13
  "000000000000", // 14
  "000000000000", // 15
  "000000000000", // 16
  "000000000000", // 17
  "000000000000", // 18
  "000000000000", // 19
};
uint32_t TableauTemps[nbr_max_de_puce];


static int32_t sequencenumber = 0;
int commande = 0; // no de la commande en cours

void setup()
{
  Serial.begin(115200);
  // set all the motor control pins to outputs
  pinMode(enA, OUTPUT);
  pinMode(in1, OUTPUT);
  pinMode(in2, OUTPUT);
  // serial RFID
  rfid.begin(9600, ENTREERFID); //
  Serial.println(ESP.getChipId(), HEX);
  //setup ethernet part
  Serial.println();
  Serial.print("Connecting to ");
  Serial.println(ssid);
  WiFi.mode(WIFI_STA);
  //WiFi.hostname(nomhost);
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  //  DHCP donc pas fixÃ© ici
  //WiFi.config(IPAddress(192, 168, IPC, IPD), IPAddress(192, 168, IPC, IPD), IPAddress(255, 255, 255, 0));
  Serial.println("");
  Serial.println("WiFi connected");
  Serial.println(ssid);
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());

  Serial.println("host: ");
  Serial.println(WiFi.hostname());
  WiFi.hostname(nomhost);
  Serial.println(WiFi.hostname());
  Serial.println("Starting UDP");
  udpin.begin(inPort);
  Serial.print("Local port: ");
  Serial.println(udpin.localPort());

  delay(100);
  // envoi le bonjour
  MonitMsg("BONJOUR", (int32_t)ESP.getChipId());
  //recupere le s puce du fichier /puces.buf
  Reprendre_config();

  // placer jesuisla en boucle timer 1s
  //zou.attach(5, jesuisla);
  // init_rfid.attach(10, rfid_port_init); ?
  // En Avant;
  digitalWrite(in1, HIGH);
  digitalWrite(in2, LOW);
  //Vitesse_moteur(1000);
}
void rfid_port_init() { // re initialisation du port rfid les 10s
  Serial.println("init rfid");
  rfid.service();
}
void jesuisla() { // envoie OSC /msg if position vitesse
  OSCMessage zouzou(OSCVar);
  zouzou.add("cmd puce vits tps ");
  zouzou.add((int32_t)commande); // commande en cours
  zouzou.add((int32_t)no_puce_actuelle);
  zouzou.add((int32_t)Vitesse_actuelle);
  zouzou.add((int32_t)(millis() / 1000));
  udpout.beginPacket(MonitIP, MonitPort);
  zouzou.send(udpout);
  udpout.endPacket();
  udpout.beginPacket(DebugIP, DebugPort);
  zouzou.send(udpout);
  udpout.endPacket();
  zouzou.empty(); // free space occupied by
}
void Arriere() {
  digitalWrite(in1, LOW);
  digitalWrite(in2, HIGH);
}

void Avant() {
  digitalWrite(in1, HIGH);
  digitalWrite(in2, LOW);
}
int Lit_Serie() {
  strncpy(tag, buf0,  TAILLE_PUCE + 1);
  for (int i = 0; i <= (TAILLE_PUCE - 1 ); i++) {
    val = 0x00;
    if (rfid.read(val)) {
      // on saute avec le start 0x02 et stop bit 0x03
      if ((val == 0x03) || (val == 0x02)) {
        break;
      }
      //Serial.println(val, HEX );
      tag[i] = (char)val;
      if (i == TAILLE_PUCE - 1) { // stop bit complete
        tag[TAILLE_PUCE] = '\0'; // on ferme ici
        //        Serial.print("Tag read: ");
        MonitMsg(tag, 1);
        Serial.print("tag ");
        Serial.println(tag);
        return (0);
      }
    }
  }
  return (1);
}
int Lit_rfid() {
  // mise en forme de la lecture rfid
  //retourne le no_puce
  //Serial.println("attente rfid");
  int i = 0;
  strncpy( tag, buf0, TAILLE_PUCE) + 1;
  for (i = 0; i <= (TAILLE_PUCE - 1); i++) {
    val = 0x00;
    if (rfid.read(val)) {
      tag[i] = '\0'; // Null
      // on saute avec le start 0x02 et stop bit 0x03
      if ( (val == 0x03) || (val == 0x02)) {
        break;
      }
      //      Serial.print(i);
      //      Serial.print(" ");
      //      Serial.print((char)val);
      //      Serial.print(" ");
      //    Serial.println(val, HEX );
      tag[i] = (char)val;

      if (i == (TAILLE_PUCE - 1) ) { // 11 digit read is complete
        tag[TAILLE_PUCE] = '\0'; // Null on ferme la chaine
        Serial.print(tag);
        for (i = 1; i <= nbr_de_puce; i++) {
          if (strcmp(tag, TableauPuces[i]) == 0) {
            puce_derniere_lue =  i;
            Serial.println(" ");
            Serial.println(i);
            MonitMsg("puce ", puce_derniere_lue);
            return (0);
          }
        }
        MonitMsg("puce inconnue ", 999);
        MonitMsg(tag, 999);
        return (99);

      }
    }
  }
}

bool MonitMsg(char debugbla[], int debugint) {
  OSCMessage envoi(OSCVar);
  envoi.add(debugbla);
  envoi.add(debugint);

  udpout.beginPacket(MonitIP, MonitPort);
  envoi.send(udpout);
  udpout.endPacket();

  udpout.beginPacket(DebugIP, DebugPort);
  envoi.send(udpout);
  udpout.endPacket();
  envoi.empty();
}
int Vitesse_moteur(int moteur, int accel) {
  int i = 0;
  moteur = abs(moteur);
  if (moteur > 1024) // filtre le max
    moteur = 1024;

  MonitMsg("vitesse", moteur);
  //Serial.println(moteur);
  //Serial.println("vitesse ");
  //Serial.print(moteur);
  //Serial.println(" acel ");
  //Serial.println(accel);
  if ( accel < 0 )    moteur = -moteur; // ARR
  accel = abs(accel);
  if ( accel > 500 || accel < 21 ) accel = rampe_moyenne;
  // en dessous de 20 ca plante !!
  // sinon on gare accel donne
  if (Vitesse_actuelle > moteur) {
    for (i = Vitesse_actuelle; i >= moteur; i = i - 20) {
      if ( i >= 0 ) {
        //Avant;
        digitalWrite(in1, HIGH);
        digitalWrite(in2, LOW);
      } else {
        //Arriere;
        digitalWrite(in1, LOW);
        digitalWrite(in2, HIGH);
      }
      analogWrite(enA, abs(i));
      delay(accel); // rampe
    }
  } else {
    for ( i = Vitesse_actuelle; i <= moteur; i = i + 20) {
      if ( i >= 0 ) {
        //Avant;
        digitalWrite(in1, HIGH);
        digitalWrite(in2, LOW);
      } else {
        //Arriere;
        digitalWrite(in1, LOW);
        digitalWrite(in2, HIGH);
      }
      analogWrite(enA, abs(i));
      delay(accel); // rampe
    }
  }
  Vitesse_actuelle = moteur;
  analogWrite(enA, abs(moteur));
}
// COMMANDES
void ArretMoteur(OSCMessage &msg) {
  commande = 0;
  Serial.println("ArretMoteur /stop");
  MonitMsg("/stop", 0);
  analogWrite(enA, 0);
  Vitesse_actuelle = 0;
}
void MoteurControl(OSCMessage &msg) {
  // met le moteur Ã  la vitesse reÃ§ue, accel
  commande = 1;
  Serial.println("/moteur");
  Vitesse_moteur(msg.getInt(0), msg.getInt(1));
}

void InitTableauPuces(OSCMessage &msg) {
  int i = 0;
  int puce = 0;
  char *buf[TAILLE_PUCE];
  Serial.println("/inittableaupuce");
  commande = 7;
  if (msg.getInt(0) > 0) {
    nbr_de_puce = abs((int) msg.getInt(0));
  } else {
    nbr_de_puce = nbr_max_de_puce;
  }
  Serial.println(nbr_de_puce);
  MonitMsg("INIT Tableau", nbr_de_puce);
  // tour pour nbr de puce total
  MonitMsg("Apprendre puce 1", 0 );
  while (Lit_Serie() != 0) {
    Serial.println("puce ? 1 ");
    delay(2000);
  }
  Serial.println(tag);
  strncpy( TableauPuces[1], tag,   TAILLE_PUCE);
  MonitMsg(TableauPuces[1], 1);
  MonitMsg("Apprendre puces", nbr_de_puce );
  for (puce = 2; puce <= nbr_de_puce; puce++) { // On doit dÃ©jÃ  connaitre la puce 1
    while (Lit_Serie() != 0) {
      Serial.print("puce? ");
      Serial.print(puce);
      delay(2000);
      Serial.println(" :");
    }
    if (strcmp(tag, TableauPuces[1]) == 0 ) {
      nbr_de_puce = puce;
      break;
    }
    strncpy( TableauPuces[puce], tag,  TAILLE_PUCE) ;
    Serial.print(tag);
    Serial.print(" ");
    Serial.println(puce);
    MonitMsg(tag, puce );
  }
  Serial.print  ("nbr de puce ok ");
  Serial.println(puce);
  MonitMsg("nbr de puce ok", puce);
}
int Reprendre_config() {
  if (!SPIFFS.begin()) {
    Serial.println("Failed to mount file system");
  }
  File configFile = SPIFFS.open("/config.json", "r");
  if (!configFile) {
    Serial.println("pb de lecture de /config.json");
    nbr_de_puce = nbr_max_de_puce;
    MonitMsg("nbr max de puce ", nbr_de_puce);
  } else {
    size_t size = configFile.size();
    if (size > 1024) {
      Serial.println("Config file size is too large");
      return 3;
    }
    // Allocate a buffer to store contents of the file.
    std::unique_ptr<char[]> buf(new char[size]);

    // We don't use String here because ArduinoJson library requires the input
    // buffer to be mutable. If you don't use ArduinoJson, you may as well
    // use configFile.readString instead.
    configFile.readBytes(buf.get(), size);

    StaticJsonBuffer<400> jsonBuffer;
    JsonObject& circuit = jsonBuffer.parseObject(buf.get());
    //circuit.printTo(Serial);
    if (!circuit.success()) {
      Serial.println("parse pb de lecture de /config.json");
      return (1);
    }
    nbr_de_puce = circuit["nbr_de_puce"];
    distance_entre_puce = circuit["distance_entre_puce"] ;
    distance_totale = circuit["distance_totale"];
    temps_boucle_total = circuit["temps_boucle_total"];
    Serial.println(nbr_de_puce);
    Serial.println(distance_entre_puce);
    Serial.println(distance_totale);
    Serial.println(temps_boucle_total);
    for ( int i = 1; i <= nbr_de_puce; i++) {
      strncpy(TableauPuces[i], circuit["tablepuces"][i - 1], TAILLE_PUCE);
      Serial.print(TableauPuces[i]);
      Serial.print(" puce:");
      Serial.println(i);
      MonitMsg(TableauPuces[i] , i);
      delay(20);
    }
  }
  configFile.close();
  return (0);
}
void SauverTableauPuces(OSCMessage & msg) {
  commande = 8;
  if (nbr_de_puce == 0) nbr_de_puce = msg.getInt(0);

  Serial.println("sauvegarde config.json ");
  if (FlashTableauPuces() == 0) {
    Serial.println("config.json sauvé");
    MonitMsg("config.json sauve ok", nbr_de_puce);
  }
}
int FlashTableauPuces() {
  Serial.println("go config.json ");
  StaticJsonBuffer<400> jsonBuffer;
  JsonObject& circuit = jsonBuffer.createObject();
  circuit["nbr_de_puce"] = nbr_de_puce;
  circuit["distance_entre_puce"] = distance_entre_puce ;
  circuit["distance_totale"] = distance_totale;
  circuit["temps_boucle_total"] = temps_boucle_total;
  JsonArray& puces = circuit.createNestedArray("tablepuces");
  for (int i = 1; i <= nbr_de_puce; i++) {
    puces.add( TableauPuces[i]);
  }
  File configFile = SPIFFS.open("/config.json", "w");
  if (!configFile) {
    Serial.println("Failed to open config file for writing");
    return (2);
  }
  circuit.printTo(configFile);
  MonitMsg("flash", nbr_de_puce);
  circuit.printTo(Serial);
  configFile.close();
  return (0);
}
void SauveEcart(OSCMessage &msg) {
  if (msg.getInt(0) > 0) {
    distance_entre_puce = msg.getInt(0);
    FlashTableauPuces();
  }
}
void SauveTempstot(OSCMessage &msg) {
  if (msg.getInt(0) > 0) {
    temps_boucle_total = msg.getInt(0);
    FlashTableauPuces();
  }
}
void Initialisation(OSCMessage &msg) {
  // la loco fait un tour complet doucement pour connaitre les puces
  // puis la loco fait un tour complet pour connaitre le temps nÃ©cessaire
  // et vÃ©rifier la lecture des puces RFID , voir faire l'init du tableau?
  // elle ne connait au dÃ©part que la puce 0, position 0
  // on ecrit le tableau sur le fs
  int i = 0;
  int puce = 0;
  commande = 2;
  val = 0x00;
  zou.detach();
  if (msg.getInt(0) > 0) {
    nbr_de_puce = abs((int) msg.getInt(0));

    Serial.print("/init");
    Serial.println(nbr_de_puce);
    MonitMsg("INIT", nbr_de_puce);
    Vitesse_moteur(700, 0);

    for (puce = 1; puce <= nbr_de_puce; puce++) { // On doit avoir le nbr de puce
      while (Lit_Serie() != 0)
        delay(200);
      strncpy( TableauPuces[puce], tag,  TAILLE_PUCE) ;
      Serial.print(tag);
      Serial.print(" ");
      Serial.println(puce);
      MonitMsg("200 puce ", puce);
      MonitMsg(TableauPuces[i], 0);
    } // on et juste avant puce 1
    //rouler a fond
    Vitesse_moteur(1000, 0);
    while (Lit_Serie() != 0) {
      delay(100);
    }
    // puce 1 declenche timer
    uint32_t temps = (uint32_t)millis();
    temps_depart = (uint32_t)millis();
    Serial.println("calcul temps ");
    Serial.println(temps_depart);
    for (puce = 2; puce <= nbr_de_puce + 1 ; puce++) {
      while (Lit_Serie() != 0) {// fait puce_derniere_lue
        delay(100);
      }
      TableauTemps[puce] = (uint32_t)millis() - temps;
      MonitMsg("201 puce_derniere_lue", puce);
    }
    temps_boucle_total = (uint32_t)millis() - temps ; // gaff au temp de lecture
    // enregistrer les parametres
    //Serial.print("temps ");
    //Serial.print(temps_boucle_total);
    //zou.attach(5, jesuisla);
    MonitMsg("210 init temps_boucle_total", temps_boucle_total );
    Serial.println("temps_boucle_total ");
    Serial.println(temps_boucle_total);
  }
  commande = 0;
  Vitesse_moteur(0, 0);
}
void Rendezvous(OSCMessage & msg) {
  // /goto iii puce temps rampe : se rendre a la puce xx en tant de temps
  commande = 3;
  int distance = 0;
  float vitesse = 0;
  int puce = 0;
  puce_a_trouver = (int) msg.getInt(0);
  temps_a_faire = (uint32_t)msg.getInt(1) ;
  rampe = (int) msg.getInt(2); // si <0 alors marche arriere
  if (puce_derniere_lue == 0  ||  puce_derniere_lue > 90  ) { // on ne connait pas la puce depart
    Serial.print("/rdv cherche puce ");
    Serial.println(puce_derniere_lue);
    MonitMsg("390 attente 1ere puce", 390);
    Vitesse_moteur(700, 0);
    while (Lit_rfid() >= 90 || puce_derniere_lue == 0  ) // on cherche la prochaine, renseigne puce_derniere_lue
      delay(200);
    no_puce_actuelle = puce_derniere_lue; // ?

    //Vitesse_moteur(0, 0);
  }
  MonitMsg("301 puce depart ", no_puce_actuelle );
  Serial.print("/rdv de ");
  Serial.print(puce_derniere_lue);
  Serial.print(" a trouver ");
  Serial.println(puce_a_trouver);
  temps_depart = (uint32_t)millis();
  temps_tot_puce = temps_depart;
  // 1 vitesse constante sur le trajet sauf accel
  // v= vitess max / (Dtot/Ttot)*t/d
  // puce devant plus grande
  if ((puce_a_trouver > puce_derniere_lue) && rampe >= 0) {
    distance = (puce_a_trouver - puce_derniere_lue) * distance_entre_puce;
  } else {
    if ((puce_a_trouver < puce_derniere_lue) && rampe >= 0) {
      // puce devant plus petite et marche avant
      distance = (puce_a_trouver - puce_derniere_lue + nbr_de_puce ) * distance_entre_puce;
    } else {
      if ((puce_a_trouver > puce_derniere_lue) && rampe < 0) { //arriere
        distance = (nbr_de_puce - puce_a_trouver - puce_derniere_lue) * distance_entre_puce;
      } else {
        if ((puce_a_trouver < puce_derniere_lue) && rampe < 0) { //arriere
          distance = (puce_derniere_lue - puce_a_trouver) * distance_entre_puce;

        } else {
          if ((puce_a_trouver = puce_derniere_lue)) { //si meme puce alors un tour complet
            distance = distance_totale;
            tour += 1;
          }
        }
      }
    }
  }
  if (distance == 0) {
    distance = distance_totale;
  }
  vitesse =  ((float)distance_totale / (float)temps_boucle_total) * ((float)temps_a_faire / (float)distance);
  vitesse = 1000 / vitesse;
  if (vitesse > 1010) {
    MonitMsg("390 ERR temps trop court tps mini", temps_boucle_total );
    vitesse = 1000;
  }
  if (vitesse < 400) {
    MonitMsg("391 ERR temps trop long", 0 );
    vitesse = 400;
  }
  Serial.println(vitesse);
  MonitMsg("302 distance ", distance);
  MonitMsg("303 vitesse calculee", (int) vitesse);
  temps_depart = (uint32_t)millis();
  Vitesse_moteur((int)vitesse, rampe); // on roule , pendant un certain temps
}
void SeRendre(OSCMessage & msg) {
  // /aller ii puce vitesse : se rendre a la puce xx a n vitesse [acceleration]
  commande = 4;
  Aller((int)msg.getInt(0), (int)msg.getInt(1), (int)msg.getInt(2) );
}
void LitPuce(OSCMessage & msg) {
  commande = 6;
  Serial.println("lit");
  zou.detach();
  MonitMsg("600 lit", 600);
}

void Ou(OSCMessage & msg) {
  commande = 9;
  //Serial.println("ou");
  //zou.attach(5, jesuisla);
  MonitMsg("derniere puce lue ", puce_derniere_lue);
}
bool Aller(int no_puce, int vitesse, int accel) {
  // aller jusqu'a la puce no_puce a vitesse
  Serial.println("Aller");
  MonitMsg("400 aller", no_puce);
  puce_a_trouver = no_puce;
  temps_depart = (uint32_t)millis();
  temps_tot_puce = temps_depart;
  rampe = accel;
  Vitesse_moteur(vitesse, accel);
  return (true);
}
void loop()
{
  // Lire la comande et executer le debut
  OSCMessage msgIN;
  int size;
  if ( (size = udpin.parsePacket()) > 0)
  {
    while (size--)
      msgIN.fill(udpin.read());

    if (!msgIN.hasError()) {
      // /stop immediat moteur et commande
      msgIN.dispatch("/stop", ArretMoteur);  // commande=0

      // /moteur ii vitesse +/- rampe (av/arr)
      //        rampe  <0 : marche arriere, 0 brutal
      msgIN.dispatch("/moteur", MoteurControl); //  commande=1

      // /init fait un tour pour decouvrir les puces, le parcours distance_totale et temps_boucle_totale
      msgIN.dispatch("/init", Initialisation);  // commande=2

      // /goto iii puce temps(ms) +/-rampe (av/arr) va Ã  la puce dans le temps donnÃ©
      msgIN.dispatch("/goto", Rendezvous);      // commande=3

      // /aller iii puce vitesse rampe
      msgIN.dispatch("/aller", SeRendre);       // commande=4

      // /lit renvoi le code de la puce lue
      msgIN.dispatch("/lit", LitPuce);          //   commande=6

      // /puces rempli le tableau avec les puce presentees a larret
      msgIN.dispatch("/puces", InitTableauPuces);  // commande=7

      // /sauvepuces enregistre le tableau dans la flash
      msgIN.dispatch("/sauvepuces", SauverTableauPuces); // commande=8

      // /ou renvoi la derniere puce lu
      msgIN.dispatch("/ou", Ou);                //  commande=9

      // /sauveecart enregistre l'ecart entre les puce dans la flash
      msgIN.dispatch("/sauveecart", SauveEcart); // commande=11

      // /sauveecart enregistre le tableau dans la flash
      msgIN.dispatch("/sauvtempstot", SauveTempstot); // commande=12
    }
    udpin.flush();
  }
  // Lire une puce et continuer une commande en cours
  if (commande != 0) {
    if (commande != 2 && commande != 7) {
      if (commande == 6) {
        Lit_Serie();
      } else {
        //puce_derniere_lue revient de Lit_rfid
        if (Lit_rfid() == 0) {
          temps_inter = (uint32_t)millis() - temps_depart ;
          temps_tot_puce += temps_inter;
          //MonitMsg("temps ", temps_inter );
          //Serial.print("puce lue ");
          //Serial.print(puce_derniere_lue);
          //Serial.print(" a trouver ");
          //Serial.println(puce_a_trouver);
          if (commande == 3 && Vitesse_actuelle > 800) {
            if ( temps_a_faire - ((uint32_t)millis() - temps_depart) < 1000 ) { // ralentir 1s avant
              Vitesse_actuelle = Vitesse_actuelle - 100;
              if (Vitesse_actuelle < 0) Vitesse_actuelle = 0;
              analogWrite(enA, Vitesse_actuelle);
              MonitMsg("305 rallenti" , puce_derniere_lue);
            }
            if ( temps_a_faire + 3000 < ((uint32_t)millis() - temps_depart  )  ) { // on laisse tomber a 3s pret
              Vitesse_moteur(0, 0);
              MonitMsg("309 temps non atteind" , puce_derniere_lue);
            }
          }
          if ( commande == 4 && Vitesse_actuelle > 800 && ( (puce_derniere_lue == puce_a_trouver - 1 && rampe > 0) || (puce_derniere_lue == puce_a_trouver + 1 && rampe < 0) )) {
            Vitesse_actuelle = Vitesse_actuelle - 100;
            if (Vitesse_actuelle < 0) Vitesse_actuelle = 0;
            analogWrite(enA, Vitesse_actuelle);
            MonitMsg("405 rallenti" , puce_derniere_lue);
          }
          if ((commande == 4 || commande == 3) && puce_derniere_lue == puce_a_trouver && tour <= 0) {
            //stopmoteur
            Vitesse_moteur(0, 0); //rampe a 0
            Serial.println(" ok ");
            MonitMsg("puce trouve" , puce_derniere_lue);
            MonitMsg("en ", (int) ((uint32_t)millis() - temps_depart) );
            temps_tot_puce = 0;
            no_puce_actuelle = puce_a_trouver;
            //puce_derniere_lue = 98;
            puce_a_trouver = 98;
            commande = 0;
          }
          no_puce_actuelle = puce_derniere_lue;
          if (puce_derniere_lue == puce_a_trouver ) {
            tour -= 1;
          }
        }
      }
    }
    delay(30);
  }

}
